#include "StdAfx.h"
#include "SimpleTextPropertyAccessor.h"

#include "ScriptletConstant.h"
#include "SimpleTextShape.h"

REGISTER_PROPERTY_ACCESSOR(SCRIPTLET_SIMPLETEXT_NODE, SimpleTextPropertyAccessor)
BOOL SimpleTextPropertyAccessor::SetProperty(CComponent* pTarget, LPCTSTR property, CComVariant value)
{
	BOOL bSuccess = __super::SetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CSimpleTextShape* simpletext = dynamic_cast<CSimpleTextShape*>(pTarget);
		if (simpletext == NULL) return bSuccess;

		USES_CONVERSION;
		//text
		if (_tcsicmp(SCRIPTLET_TEXT_NODE, property) == 0)
		{
			simpletext->SetText(OLE2CT(value.bstrVal));
			simpletext->Invalidate();
			bSuccess = TRUE;
		}
		// [:2008-09-22] Bold 
		else if (_tcsicmp(SCRIPTLET_BOLD_NODE, property) == 0)
		{
			simpletext->SetBold(value.boolVal);
			simpletext->Invalidate();
			bSuccess = TRUE;
		}
		// [:2008-09-22] Bold 
		else if (_tcsicmp(L"font.foreground", property) == 0)
		{
			if( value.vt == VT_BSTR )
			{
				COLORREF clrFore = XMLUtil::ColorFromString(OLE2CT(value.bstrVal));
				simpletext->SetFontColor(clrFore);
				simpletext->Invalidate();
				bSuccess = TRUE;
			}
		}
		else if (_tcsicmp(L"trimming", property) == 0)
		{
			if( value.vt == VT_BSTR )
			{
				BOOL bTrimming = _tcscmp(OLE2CT(value.bstrVal), L"true");
				simpletext->SetTrimming(bTrimming);
				simpletext->Invalidate();
				bSuccess = TRUE;
			}
		}
	}
	return bSuccess;
}
BOOL SimpleTextPropertyAccessor::GetProperty(CComponent* pTarget, LPCTSTR property, CComVariant& value)
{
	BOOL bSuccess = __super::GetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CSimpleTextShape* simpletext = dynamic_cast<CSimpleTextShape*>(pTarget);
		if (simpletext == NULL) return bSuccess;

		USES_CONVERSION;
		//text
		if (_tcsicmp(SCRIPTLET_TEXT_NODE, property) == 0)
		{
			value = simpletext->GetText();
			bSuccess = TRUE;
		}
	}
	return bSuccess;
}

REGISTER_PROPERTY_ACCESSOR(SCRIPTLET_XMLTEXT_NODE, XMLTextPropertyAccessor)
REGISTER_PROPERTY_ACCESSOR(SCRIPTLET_STATETEXT_NODE, StateTextPropertyAccessor)